package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;


/**
 * 实体[WFCustomProcess] 数据对象
 */
@TableName(value = "T_SRFWFCUSTOMPROCESS",resultMap = "WFCustomProcessResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class WFCustomProcess extends EntityBase implements Serializable{

    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private String memo;
    private String processobject;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    private String version;
    @TableId(value= "wfcustomprocessid",type=IdType.UUID)//指定主键生成策略
    private String wfcustomprocessid;
    private String wfcustomprocessname;
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[备注]
     *  @param memo
     */
    public void setMemo(String memo){
        if(StringUtils.isEmpty(memo))
            memo=null;
        this.memo = memo;
        this.set("memodirtyflag",true);
    }
    /**
     *  获取属性值[备注]
     */
    public String getMemo(){
        return this.memo;
    }
    /**
     *  重置属性值[备注]
     */
    public void resetMemo(){
        this.set("memodirtyflag",false);
        this.memo = null;
    }
    /**
     *  设置属性值[处理对象]
     *  @param processobject
     */
    public void setProcessobject(String processobject){
        if(StringUtils.isEmpty(processobject))
            processobject=null;
        this.processobject = processobject;
        this.set("processobjectdirtyflag",true);
    }
    /**
     *  获取属性值[处理对象]
     */
    public String getProcessobject(){
        return this.processobject;
    }
    /**
     *  重置属性值[处理对象]
     */
    public void resetProcessobject(){
        this.set("processobjectdirtyflag",false);
        this.processobject = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[处理版本]
     *  @param version
     */
    public void setVersion(String version){
        if(StringUtils.isEmpty(version))
            version=null;
        this.version = version;
        this.set("versiondirtyflag",true);
    }
    /**
     *  获取属性值[处理版本]
     */
    public String getVersion(){
        return this.version;
    }
    /**
     *  重置属性值[处理版本]
     */
    public void resetVersion(){
        this.set("versiondirtyflag",false);
        this.version = null;
    }
    /**
     *  设置属性值[工作流预定义处理标识]
     *  @param wfcustomprocessid
     */
    public void setWfcustomprocessid(String wfcustomprocessid){
        if(StringUtils.isEmpty(wfcustomprocessid))
            wfcustomprocessid=null;
        this.wfcustomprocessid = wfcustomprocessid;
        this.set("wfcustomprocessiddirtyflag",true);
    }
    /**
     *  获取属性值[工作流预定义处理标识]
     */
    public String getWfcustomprocessid(){
        return this.wfcustomprocessid;
    }
    /**
     *  重置属性值[工作流预定义处理标识]
     */
    public void resetWfcustomprocessid(){
        this.set("wfcustomprocessiddirtyflag",false);
        this.wfcustomprocessid = null;
    }
    /**
     *  设置属性值[工作流预定义处理名称]
     *  @param wfcustomprocessname
     */
    public void setWfcustomprocessname(String wfcustomprocessname){
        if(StringUtils.isEmpty(wfcustomprocessname))
            wfcustomprocessname=null;
        this.wfcustomprocessname = wfcustomprocessname;
        this.set("wfcustomprocessnamedirtyflag",true);
    }
    /**
     *  获取属性值[工作流预定义处理名称]
     */
    public String getWfcustomprocessname(){
        return this.wfcustomprocessname;
    }
    /**
     *  重置属性值[工作流预定义处理名称]
     */
    public void resetWfcustomprocessname(){
        this.set("wfcustomprocessnamedirtyflag",false);
        this.wfcustomprocessname = null;
    }
    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCreatedate();
        resetCreateman();
        resetMemo();
        resetProcessobject();
        resetUpdatedate();
        resetUpdateman();
        resetVersion();
        resetWfcustomprocessid();
        resetWfcustomprocessname();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public WFCustomProcess copyTo(WFCustomProcess targetEntity)
	{
		BeanCopier copier=BeanCopier.create(WFCustomProcess.class, WFCustomProcess.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetWfcustomprocessid();
		return targetEntity;
	}
}